diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/test/wifi-mac-ofdma-test.cc ns-3.44/src/wifi/test/wifi-mac-ofdma-test.cc
--- ns-3.43/src/wifi/test/wifi-mac-ofdma-test.cc	2024-10-09 16:41:10.136656800 -0700
+++ ns-3.44/src/wifi/test/wifi-mac-ofdma-test.cc	2025-03-09 16:55:49.811372800 -0700
@@ -2227,7 +2303,7 @@
         client1->SetRemote(m_sockets[i]);
         wifiStaNodes.Get(i)->AddApplication(client1);
         client1->SetStartTime(Seconds(1.005) + i * MilliSeconds(1));
-        client1->SetStopTime(Seconds(2.0));
+        client1->SetStopTime(Seconds(2));
 
         // packets to be included in HE TB PPDUs are generated (by Transmit()) when
         // the first Basic Trigger Frame is sent by the AP
@@ -2235,8 +2311,8 @@
         Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
         server->SetLocal(m_sockets[i]);
         wifiApNode.Get(0)->AddApplication(server);
-        server->SetStartTime(Seconds(0.0));
-        server->SetStopTime(Seconds(3.0));
+        server->SetStartTime(Seconds(0));
+        server->SetStopTime(Seconds(3));
     }
 
     Config::Connect("/NodeList/*/ApplicationList/0/$ns3::PacketSocketServer/Rx",
@@ -2260,10 +2336,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief wifi MAC OFDMA Test Suite
+ * @brief wifi MAC OFDMA Test Suite
  */
 class WifiMacOfdmaTestSuite : public TestSuite
 {
@@ -2283,54 +2359,78 @@
         for (const auto scenario :
              {WifiOfdmaScenario::HE, WifiOfdmaScenario::HE_EHT, WifiOfdmaScenario::EHT})
         {
-            AddTestCase(new OfdmaAckSequenceTest(20,
-                                                 WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE,
-                                                 10000,
-                                                 5632,
-                                                 15,
-                                                 muEdcaParameterSet,
-                                                 scenario),
-                        TestCase::Duration::QUICK);
-            AddTestCase(new OfdmaAckSequenceTest(20,
-                                                 WifiAcknowledgment::DL_MU_AGGREGATE_TF,
-                                                 10000,
-                                                 5632,
-                                                 15,
-                                                 muEdcaParameterSet,
-                                                 scenario),
-                        TestCase::Duration::QUICK);
-            AddTestCase(new OfdmaAckSequenceTest(20,
-                                                 WifiAcknowledgment::DL_MU_TF_MU_BAR,
-                                                 10000,
-                                                 5632,
-                                                 15,
-                                                 muEdcaParameterSet,
-                                                 scenario),
-                        TestCase::Duration::QUICK);
-            AddTestCase(new OfdmaAckSequenceTest(40,
-                                                 WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE,
-                                                 10000,
-                                                 0,
-                                                 15,
-                                                 muEdcaParameterSet,
-                                                 scenario),
+            AddTestCase(new OfdmaAckSequenceTest(
+                            {.channelWidth = MHz_u{20},
+                             .dlMuAckType = WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE,
+                             .maxAmpduSize = 10000,
+                             .txopLimit = 5632,
+                             .continueTxopAfterBsrp = false, // unused because non-zero TXOP limit
+                             .skipMuRtsBeforeBsrp = true,
+                             .protectedIfResponded = false,
+                             .nPktsPerSta = 15,
+                             .muEdcaParameterSet = muEdcaParameterSet,
+                             .scenario = scenario}),
                         TestCase::Duration::QUICK);
-            AddTestCase(new OfdmaAckSequenceTest(40,
-                                                 WifiAcknowledgment::DL_MU_AGGREGATE_TF,
-                                                 10000,
-                                                 0,
-                                                 15,
-                                                 muEdcaParameterSet,
-                                                 scenario),
+            AddTestCase(new OfdmaAckSequenceTest(
+                            {.channelWidth = MHz_u{20},
+                             .dlMuAckType = WifiAcknowledgment::DL_MU_AGGREGATE_TF,
+                             .maxAmpduSize = 10000,
+                             .txopLimit = 5632,
+                             .continueTxopAfterBsrp = false, // unused because non-zero TXOP limit
+                             .skipMuRtsBeforeBsrp = false,
+                             .protectedIfResponded = false,
+                             .nPktsPerSta = 15,
+                             .muEdcaParameterSet = muEdcaParameterSet,
+                             .scenario = scenario}),
                         TestCase::Duration::QUICK);
-            AddTestCase(new OfdmaAckSequenceTest(40,
-                                                 WifiAcknowledgment::DL_MU_TF_MU_BAR,
-                                                 10000,
-                                                 0,
-                                                 15,
-                                                 muEdcaParameterSet,
-                                                 scenario),
+            AddTestCase(new OfdmaAckSequenceTest(
+                            {.channelWidth = MHz_u{20},
+                             .dlMuAckType = WifiAcknowledgment::DL_MU_TF_MU_BAR,
+                             .maxAmpduSize = 10000,
+                             .txopLimit = 5632,
+                             .continueTxopAfterBsrp = false, // unused because non-zero TXOP limit
+                             .skipMuRtsBeforeBsrp = true,
+                             .protectedIfResponded = true,
+                             .nPktsPerSta = 15,
+                             .muEdcaParameterSet = muEdcaParameterSet,
+                             .scenario = scenario}),
                         TestCase::Duration::QUICK);
+            AddTestCase(
+                new OfdmaAckSequenceTest({.channelWidth = MHz_u{40},
+                                          .dlMuAckType = WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE,
+                                          .maxAmpduSize = 10000,
+                                          .txopLimit = 0,
+                                          .continueTxopAfterBsrp = true,
+                                          .skipMuRtsBeforeBsrp = false,
+                                          .protectedIfResponded = false,
+                                          .nPktsPerSta = 15,
+                                          .muEdcaParameterSet = muEdcaParameterSet,
+                                          .scenario = scenario}),
+                TestCase::Duration::QUICK);
+            AddTestCase(
+                new OfdmaAckSequenceTest({.channelWidth = MHz_u{40},
+                                          .dlMuAckType = WifiAcknowledgment::DL_MU_AGGREGATE_TF,
+                                          .maxAmpduSize = 10000,
+                                          .txopLimit = 0,
+                                          .continueTxopAfterBsrp = false,
+                                          .skipMuRtsBeforeBsrp = true,
+                                          .protectedIfResponded = false,
+                                          .nPktsPerSta = 15,
+                                          .muEdcaParameterSet = muEdcaParameterSet,
+                                          .scenario = scenario}),
+                TestCase::Duration::QUICK);
+            AddTestCase(
+                new OfdmaAckSequenceTest({.channelWidth = MHz_u{40},
+                                          .dlMuAckType = WifiAcknowledgment::DL_MU_TF_MU_BAR,
+                                          .maxAmpduSize = 10000,
+                                          .txopLimit = 0,
+                                          .continueTxopAfterBsrp = true,
+                                          .skipMuRtsBeforeBsrp = false,
+                                          .protectedIfResponded = true,
+                                          .nPktsPerSta = 15,
+                                          .muEdcaParameterSet = muEdcaParameterSet,
+                                          .scenario = scenario}),
+                TestCase::Duration::QUICK);
         }
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/test/wifi-mac-queue-test.cc ns-3.44/src/wifi/test/wifi-mac-queue-test.cc
--- ns-3.43/src/wifi/test/wifi-mac-queue-test.cc	2024-10-09 16:41:10.136656800 -0700
+++ ns-3.44/src/wifi/test/wifi-mac-queue-test.cc	2025-03-09 16:55:49.811372800 -0700
@@ -16,10 +16,10 @@
 using namespace ns3;
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Test DROP_OLDEST setting.
+ * @brief Test DROP_OLDEST setting.
  *
  * This test verifies the correctness of DROP_OLDEST policy when packets
  * are pushed into the front of the queue. This case is not handled
@@ -29,7 +29,7 @@
 {
   public:
     /**
-     * \brief Constructor
+     * @brief Constructor
      */
     WifiMacQueueDropOldestTest();
 
@@ -112,10 +112,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Test extraction of expired MPDUs from MAC queue container
+ * @brief Test extraction of expired MPDUs from MAC queue container
  *
  * This test verifies the correctness of the WifiMacQueueContainer methods
  * (ExtractExpiredMpdus and ExtractAllExpiredMpdus) that extract MPDUs with
@@ -132,9 +132,9 @@
     /**
      * Enqueue a new MPDU into the container.
      *
-     * \param rxAddr Receiver Address of the MPDU
-     * \param inflight whether the MPDU is inflight
-     * \param expiryTime the expity time for the MPDU
+     * @param rxAddr Receiver Address of the MPDU
+     * @param inflight whether the MPDU is inflight
+     * @param expiryTime the expity time for the MPDU
      */
     void Enqueue(Mac48Address rxAddr, bool inflight, Time expiryTime);
 
@@ -418,10 +418,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief Wifi MAC Queue Test Suite
+ * @brief Wifi MAC Queue Test Suite
  */
 class WifiMacQueueTestSuite : public TestSuite
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/test/wifi-mlo-test.cc ns-3.44/src/wifi/test/wifi-mlo-test.cc
--- ns-3.43/src/wifi/test/wifi-mlo-test.cc	2024-10-09 16:41:10.136656800 -0700
+++ ns-3.44/src/wifi/test/wifi-mlo-test.cc	2025-03-09 16:55:49.811372800 -0700
@@ -71,11 +71,11 @@
 
     rnr.AddTbttInformationField(nbrId);
     tbttId = rnr.GetNTbttInformationFields(nbrId) - 1;
-    rnr.SetMldParameters(nbrId, tbttId, 0, 0, 0);
+    rnr.SetMldParameters(nbrId, tbttId, {0, 0, 0, 1, 1});
 
     rnr.AddTbttInformationField(nbrId);
     tbttId = rnr.GetNTbttInformationFields(nbrId) - 1;
-    rnr.SetMldParameters(nbrId, tbttId, 5, 0, 0);
+    rnr.SetMldParameters(nbrId, tbttId, {5, 0, 0, 1, 0});
 
     // Add a third Neighbor AP Information field with MLD Parameters; none of the
     // TBTT Information fields is related to an AP affiliated to the same AP MLD
@@ -85,11 +85,11 @@
 
     rnr.AddTbttInformationField(nbrId);
     tbttId = rnr.GetNTbttInformationFields(nbrId) - 1;
-    rnr.SetMldParameters(nbrId, tbttId, 3, 0, 0);
+    rnr.SetMldParameters(nbrId, tbttId, {3, 0, 0, 0, 1});
 
     rnr.AddTbttInformationField(nbrId);
     tbttId = rnr.GetNTbttInformationFields(nbrId) - 1;
-    rnr.SetMldParameters(nbrId, tbttId, 4, 0, 0);
+    rnr.SetMldParameters(nbrId, tbttId, {4, 0, 0, 0, 0});
 
     // Add a fourth Neighbor AP Information field with MLD Parameters; the first
     // TBTT Information field is not related to an AP affiliated to the same AP MLD
@@ -99,11 +99,11 @@
 
     rnr.AddTbttInformationField(nbrId);
     tbttId = rnr.GetNTbttInformationFields(nbrId) - 1;
-    rnr.SetMldParameters(nbrId, tbttId, 6, 0, 0);
+    rnr.SetMldParameters(nbrId, tbttId, {6, 0, 0, 1, 1});
 
     rnr.AddTbttInformationField(nbrId);
     tbttId = rnr.GetNTbttInformationFields(nbrId) - 1;
-    rnr.SetMldParameters(nbrId, tbttId, 0, 0, 0);
+    rnr.SetMldParameters(nbrId, tbttId, {0, 0, 0, 0, 0});
 
     // check implementation of WifiAssocManager::GetNextAffiliatedAp()
     auto ret = WifiAssocManager::GetNextAffiliatedAp(rnr, 0);
@@ -178,6 +178,7 @@
 
     std::vector<Ptr<WifiPhy>> phys;
     std::vector<Ptr<FrameExchangeManager>> feManagers;
+    std::vector<Ptr<WifiRemoteStationManager>> rsManagers;
 
     for (std::size_t i = 0; i < nLinks; ++i)
     {
@@ -185,9 +186,11 @@
         phy->SetPhyId(i);
         phys.emplace_back(phy);
         feManagers.emplace_back(CreateObject<TestFrameExchangeManager>());
+        rsManagers.emplace_back(CreateObject<TestRemoteStationManager>());
     }
     mac->SetWifiPhys(phys); // create links containing the given PHYs
     mac->SetFrameExchangeManagers(feManagers);
+    mac->SetWifiRemoteStationManagers(rsManagers);
     mac->GetTxop()->SetWifiMac(mac);
 
     // set CWmin of each Txop LinkEntity to the link ID, so that we can check where it has moved
@@ -220,6 +223,12 @@
             +linkId,
             text << ": Link ID stored by FrameExchangeManager has not been updated");
 
+        NS_TEST_EXPECT_MSG_EQ(
+            +DynamicCast<TestRemoteStationManager>(mac->GetWifiRemoteStationManager(linkId))
+                 ->GetLinkId(),
+            +linkId,
+            text << ": Link ID stored by RemoteStationManager has not been updated");
+
         NS_TEST_EXPECT_MSG_EQ(mac->GetTxop()->GetMinCw(linkId),
                               +phyId,
                               text << ": Txop Link entity " << +phyId
@@ -634,7 +643,7 @@
 MultiLinkOperationsTestBase::DoSetup()
 {
     RngSeedManager::SetSeed(1);
-    RngSeedManager::SetRun(3);
+    RngSeedManager::SetRun(5);
     int64_t streamNumber = 30;
 
     NodeContainer wifiApNode;
@@ -668,6 +677,8 @@
 
     WifiMacHelper mac;
     mac.SetType("ns3::StaWifiMac", // default SSID
+                "MaxMissedBeacons",
+                UintegerValue(1e6), // do not deassociate
                 "ActiveProbing",
                 BooleanValue(false));
 
@@ -797,6 +808,9 @@
         m_staMacs[aid]->SetSsid(Ssid("ns-3-ssid"));
         return;
     }
+    // stop generation of beacon frames in order to avoid interference
+    m_apMac->SetAttribute("BeaconGeneration", BooleanValue(false));
+
     // wait some time (5ms) to allow the completion of association before generating traffic
     Simulator::Schedule(MilliSeconds(5), &MultiLinkOperationsTestBase::StartTraffic, this);
 }
@@ -1103,7 +1117,7 @@
         NS_TEST_EXPECT_MSG_EQ(rnr->GetNTbttInformationFields(nbrApInfoId),
                               1,
                               "Expected only one TBTT Info subfield per Neighbor AP Info");
-        uint8_t nbrLinkId = rnr->GetLinkId(nbrApInfoId, 0);
+        uint8_t nbrLinkId = rnr->GetMldParameters(nbrApInfoId, 0).linkId;
         NS_TEST_EXPECT_MSG_EQ(rnr->GetBssid(nbrApInfoId, 0),
                               m_apMac->GetFrameExchangeManager(nbrLinkId)->GetAddress(),
                               "BSSID advertised in Neighbor AP Info field "
@@ -1162,7 +1176,7 @@
         NS_TEST_EXPECT_MSG_EQ(rnr->GetNTbttInformationFields(nbrApInfoId),
                               1,
                               "Expected only one TBTT Info subfield per Neighbor AP Info");
-        uint8_t nbrLinkId = rnr->GetLinkId(nbrApInfoId, 0);
+        uint8_t nbrLinkId = rnr->GetMldParameters(nbrApInfoId, 0).linkId;
         NS_TEST_EXPECT_MSG_EQ(rnr->GetBssid(nbrApInfoId, 0),
                               m_apMac->GetFrameExchangeManager(nbrLinkId)->GetAddress(),
                               "BSSID advertised in Neighbor AP Info field "
@@ -1439,12 +1453,12 @@
         const auto& apChannel = m_apMac->GetWifiPhy(apLinkId)->GetOperatingChannel();
 
         auto width = apChannel.GetTotalWidth();
-        auto primary20 = apChannel.GetPrimaryChannelIndex(20);
+        auto primary20 = apChannel.GetPrimaryChannelIndex(MHz_u{20});
 
-        if (width > 80 && !m_support160MHzOp)
+        if (width > MHz_u{80} && !m_support160MHzOp)
         {
-            width = 80;
-            primary20 -= apChannel.GetPrimaryChannelIndex(80) * 4;
+            width = MHz_u{80};
+            primary20 -= apChannel.GetPrimaryChannelIndex(MHz_u{80}) * 4;
         }
 
         NS_TEST_EXPECT_MSG_EQ(+staChannel.GetNumber(),
@@ -1460,7 +1474,7 @@
         NS_TEST_EXPECT_MSG_EQ(+staChannel.GetPhyBand(),
                               +apChannel.GetPhyBand(),
                               "Incorrect operating PHY band for STA on link " << +staLinkId);
-        NS_TEST_EXPECT_MSG_EQ(+staChannel.GetPrimaryChannelIndex(20),
+        NS_TEST_EXPECT_MSG_EQ(+staChannel.GetPrimaryChannelIndex(MHz_u{20}),
                               +primary20,
                               "Incorrect operating primary channel index for STA on link "
                                   << +staLinkId);
@@ -1592,9 +1606,9 @@
                                                                      << hdr.IsFromDs() << ")");
     }
 
-    if (width > 80 && !m_support160MHzOp)
+    if (width > MHz_u{80} && !m_support160MHzOp)
     {
-        width = 80;
+        width = MHz_u{80};
     }
     NS_TEST_EXPECT_MSG_EQ(txvector.GetChannelWidth(), width, "Unexpected TX width");
 
